---
title: Create MFA User Device (FIDO2)
description: The sample shows the POST {{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/devices operation to add a FIDO2 device to the specified user resource.
component: pingone-api
page_id: pingone-api:mfa:users/mfa-devices/fido2-biometrics-devices/create-mfa-user-device-fido2---security_key
canonical_url: https://developer.pingidentity.com/pingone-api/mfa/users/mfa-devices/fido2-biometrics-devices/create-mfa-user-device-fido2---security_key.html
section_ids:
  headers: Headers
  body: Body
  example-request: Example Request
  example-response: Example Response
---

# Create MFA User Device (FIDO2)

##

```none
POST {{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/devices
```

The sample shows the `POST {{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/devices` operation to add a FIDO2 device to the specified user resource.

> **Collapse: Request Model**
>
> | Property          | Type   | Required? |
> | ----------------- | ------ | --------- |
> | `type`            | String | Required  |
> | `rp.id`           | String | Required  |
> | `rp.name`         | String | Required  |
> | `policy.id`       | String | Required  |
> | `block.status`    | String | Optional  |
> | `block.blockedAt` | Date   | Optional  |
> | `lock.status`     | String | Optional  |
> | `lock.expiresAt`  | Date   | Optional  |
> | `policy.id`       | String | Optional  |
> | `policy.type`     | String | Optional  |
> | `nickname`        | String | Optional  |
>
> Refer to the [Device properties](#device-properties) data model for full property descriptions.

### Headers

Authorization      Bearer {{accessToken}}

Content-Type      application/json

### Body

raw ( application/json )

```json
{
    "type": "FIDO2",
    "rp": {
        "id": "pingone.com",
        "name": "PingOne"
    },
    "policy": {
        "id": "{{deviceAuthenticationPolicyID}}"
    }
}
```

##

### Example Request

* cURL

* C#

* Go

* HTTP

* Java

* jQuery

* NodeJS

* Python

* PHP

* Ruby

* Swift

```shell
curl --location --globoff '{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/devices' \
--header 'Content-Type: application/json' \
--header 'Authorization: Bearer {{accessToken}}' \
--data '{
    "type": "FIDO2",
    "rp": {
        "id": "pingone.com",
        "name": "PingOne"
    },
    "policy": {
        "id": "{{deviceAuthenticationPolicyID}}"
    }
}'
```

```csharp
var options = new RestClientOptions("{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/devices")
{
  MaxTimeout = -1,
};
var client = new RestClient(options);
var request = new RestRequest("", Method.Post);
request.AddHeader("Content-Type", "application/json");
request.AddHeader("Authorization", "Bearer {{accessToken}}");
var body = @"{" + "\n" +
@"    ""type"": ""FIDO2""," + "\n" +
@"    ""rp"": {" + "\n" +
@"        ""id"": ""pingone.com""," + "\n" +
@"        ""name"": ""PingOne""" + "\n" +
@"    }," + "\n" +
@"    ""policy"": {" + "\n" +
@"        ""id"": ""{{deviceAuthenticationPolicyID}}""" + "\n" +
@"    }" + "\n" +
@"}";
request.AddStringBody(body, DataFormat.Json);
RestResponse response = await client.ExecuteAsync(request);
Console.WriteLine(response.Content);
```

```golang
package main

import (
  "fmt"
  "strings"
  "net/http"
  "io"
)

func main() {

  url := "{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/devices"
  method := "POST"

  payload := strings.NewReader(`{
    "type": "FIDO2",
    "rp": {
        "id": "pingone.com",
        "name": "PingOne"
    },
    "policy": {
        "id": "{{deviceAuthenticationPolicyID}}"
    }
}`)

  client := &http.Client {
  }
  req, err := http.NewRequest(method, url, payload)

  if err != nil {
    fmt.Println(err)
    return
  }
  req.Header.Add("Content-Type", "application/json")
  req.Header.Add("Authorization", "Bearer {{accessToken}}")

  res, err := client.Do(req)
  if err != nil {
    fmt.Println(err)
    return
  }
  defer res.Body.Close()

  body, err := io.ReadAll(res.Body)
  if err != nil {
    fmt.Println(err)
    return
  }
  fmt.Println(string(body))
}
```

```http
POST /v1/environments/{{envID}}/users/{{userID}}/devices HTTP/1.1
Host: {{apiPath}}
Content-Type: application/json
Authorization: Bearer {{accessToken}}

{
    "type": "FIDO2",
    "rp": {
        "id": "pingone.com",
        "name": "PingOne"
    },
    "policy": {
        "id": "{{deviceAuthenticationPolicyID}}"
    }
}
```

```java
OkHttpClient client = new OkHttpClient().newBuilder()
  .build();
MediaType mediaType = MediaType.parse("application/json");
RequestBody body = RequestBody.create(mediaType, "{\n    \"type\": \"FIDO2\",\n    \"rp\": {\n        \"id\": \"pingone.com\",\n        \"name\": \"PingOne\"\n    },\n    \"policy\": {\n        \"id\": \"{{deviceAuthenticationPolicyID}}\"\n    }\n}");
Request request = new Request.Builder()
  .url("{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/devices")
  .method("POST", body)
  .addHeader("Content-Type", "application/json")
  .addHeader("Authorization", "Bearer {{accessToken}}")
  .build();
Response response = client.newCall(request).execute();
```

```javascript
var settings = {
  "url": "{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/devices",
  "method": "POST",
  "timeout": 0,
  "headers": {
    "Content-Type": "application/json",
    "Authorization": "Bearer {{accessToken}}"
  },
  "data": JSON.stringify({
    "type": "FIDO2",
    "rp": {
      "id": "pingone.com",
      "name": "PingOne"
    },
    "policy": {
      "id": "{{deviceAuthenticationPolicyID}}"
    }
  }),
};

$.ajax(settings).done(function (response) {
  console.log(response);
});
```

```javascript
var request = require('request');
var options = {
  'method': 'POST',
  'url': '{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/devices',
  'headers': {
    'Content-Type': 'application/json',
    'Authorization': 'Bearer {{accessToken}}'
  },
  body: JSON.stringify({
    "type": "FIDO2",
    "rp": {
      "id": "pingone.com",
      "name": "PingOne"
    },
    "policy": {
      "id": "{{deviceAuthenticationPolicyID}}"
    }
  })

};
request(options, function (error, response) {
  if (error) throw new Error(error);
  console.log(response.body);
});
```

```python
import requests
import json

url = "{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/devices"

payload = json.dumps({
  "type": "FIDO2",
  "rp": {
    "id": "pingone.com",
    "name": "PingOne"
  },
  "policy": {
    "id": "{{deviceAuthenticationPolicyID}}"
  }
})
headers = {
  'Content-Type': 'application/json',
  'Authorization': 'Bearer {{accessToken}}'
}

response = requests.request("POST", url, headers=headers, data=payload)

print(response.text)
```

```php
<?php
require_once 'HTTP/Request2.php';
$request = new HTTP_Request2();
$request->setUrl('{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/devices');
$request->setMethod(HTTP_Request2::METHOD_POST);
$request->setConfig(array(
  'follow_redirects' => TRUE
));
$request->setHeader(array(
  'Content-Type' => 'application/json',
  'Authorization' => 'Bearer {{accessToken}}'
));
$request->setBody('{\n    "type": "FIDO2",\n    "rp": {\n        "id": "pingone.com",\n        "name": "PingOne"\n    },\n    "policy": {\n        "id": "{{deviceAuthenticationPolicyID}}"\n    }\n}');
try {
  $response = $request->send();
  if ($response->getStatus() == 200) {
    echo $response->getBody();
  }
  else {
    echo 'Unexpected HTTP status: ' . $response->getStatus() . ' ' .
    $response->getReasonPhrase();
  }
}
catch(HTTP_Request2_Exception $e) {
  echo 'Error: ' . $e->getMessage();
}
```

```ruby
require "uri"
require "json"
require "net/http"

url = URI("{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/devices")

http = Net::HTTP.new(url.host, url.port);
request = Net::HTTP::Post.new(url)
request["Content-Type"] = "application/json"
request["Authorization"] = "Bearer {{accessToken}}"
request.body = JSON.dump({
  "type": "FIDO2",
  "rp": {
    "id": "pingone.com",
    "name": "PingOne"
  },
  "policy": {
    "id": "{{deviceAuthenticationPolicyID}}"
  }
})

response = http.request(request)
puts response.read_body
```

```swift
let parameters = "{\n    \"type\": \"FIDO2\",\n    \"rp\": {\n        \"id\": \"pingone.com\",\n        \"name\": \"PingOne\"\n    },\n    \"policy\": {\n        \"id\": \"{{deviceAuthenticationPolicyID}}\"\n    }\n}"
let postData = parameters.data(using: .utf8)

var request = URLRequest(url: URL(string: "{{apiPath}}/v1/environments/{{envID}}/users/{{userID}}/devices")!,timeoutInterval: Double.infinity)
request.addValue("application/json", forHTTPHeaderField: "Content-Type")
request.addValue("Bearer {{accessToken}}", forHTTPHeaderField: "Authorization")

request.httpMethod = "POST"
request.httpBody = postData

let task = URLSession.shared.dataTask(with: request) { data, response, error in
  guard let data = data else {
    print(String(describing: error))
    return
  }
  print(String(data: data, encoding: .utf8)!)
}

task.resume()
```

### Example Response

201 Created

```json
{
    "_links": {
        "self": {
            "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/users/b30ac647-e33e-464f-a6ea-0275082d4c26/devices/5eba3946-1f22-43b4-b603-93c1016f1b72"
        },
        "environment": {
            "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
        },
        "user": {
            "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/users/b30ac647-e33e-464f-a6ea-0275082d4c26"
        },
        "device.activate": {
            "href": "https://api.pingone.eu/v1/environments/abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6/users/b30ac647-e33e-464f-a6ea-0275082d4c26/devices/5eba3946-1f22-43b4-b603-93c1016f1b72"
        }
    },
    "id": "5eba3946-1f22-43b4-b603-93c1016f1b72",
    "environment": {
        "id": "abfba8f6-49eb-49f5-a5d9-80ad5c98f9f6"
    },
    "user": {
        "id": "b30ac647-e33e-464f-a6ea-0275082d4c26"
    },
    "type": "FIDO2",
    "status": "ACTIVATION_REQUIRED",
    "createdAt": "2023-06-12T14:13:29.956Z",
    "updatedAt": "2023-06-12T14:13:29.956Z",
    "rp": {
        "id": "pingone.com",
        "name": "PingOne"
    },
    "publicKeyCredentialCreationOptions": "{\"rp\":{\"id\":\"pingone.com\",\"name\":\"PingOne\"},\"user\":{\"id\":[-45,58,-93,2,-16,117,36,-118,55,126,-86,108,-21,-107,20,89,77,-32,65,29,125,-65,-13,-80,111,21,-28,99,61,59,106,42],\"displayName\":\"antonik_adham\",\"name\":\"antonik_adham\"},\"challenge\":[117,67,-93,-39,-19,5,30,26,60,-56,-67,-112,47,-95,-8,67,103,7,-16,-112,-75,76,58,-43,-2,66,-54,10,73,-82,-90,-77],\"pubKeyCredParams\":[{\"type\":\"public-key\",\"alg\":\"-7\"},{\"type\":\"public-key\",\"alg\":\"-37\"},{\"type\":\"public-key\",\"alg\":\"-257\"}],\"timeout\":120000,\"excludeCredentials\":[],\"authenticatorSelection\":{\"residentKey\":\"required\",\"requireResidentKey\":true,\"userVerification\":\"required\"},\"attestation\":\"direct\"}"
}
```
